///**
// * Copyright (C) 2012 - 101loops.com <dev@101loops.com>
// *
// * Licensed under the Apache License, Version 2.0 (the "License");
// * you may not use this file except in compliance with the License.
// * You may obtain a copy of the License at
// *
// *         http://www.apache.org/licenses/LICENSE-2.0
// *
// * Unless required by applicable law or agreed to in writing, software
// * distributed under the License is distributed on an "AS IS" BASIS,
// * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// * See the License for the specific language governing permissions and
// * limitations under the License.
// */
//package com.crashnote.core.collect.impl.excp;
//
///**
// * Implementation of the {@link ExcpStackCollector}; optimized for small output, not performance.
// * <p/>
// * Usually traces contain a lot of redundant information, because often the 'change' from line
// * to line is minimal (e.g. stays with same package, class or method). By considering the
// * last value of an information and substituting it with a placeholder '*' those redundancies
// * can be minimized without a big impact on performance. On the server side they can be
// * re-created and saved complete to the database.
// * <p/>
// */
//public class OptExcpStackCollector<C extends Config>
//        extends FastExcpStackCollector<C> {
//
//    // SETUP ======================================================================================
//
//    public OptExcpStackCollector(final C config) {
//        super(config);
//    }
//
//    // INTERFACE ==================================================================================
//
//    // TODO: benchmark this optimization vs gzip only (considering performance & output size)
//
//    *//*
//    @Override
//    public DataObject collectTrace(String excpMsg, String excpCls, StackTraceElement[] stackTrace) {
//        DataObject excp = newExcp(excpMsg, excpCls);
//        {
//            String lastCls = "";
//            String lastPckg = "";
//            String lastMeth = "";
//            String lastFName = "";
//            String lastFType = "";
//
//            int count = 0;
//
//            DataArray trace = createDataArr();
//            for (final StackTraceElement element : stackTrace) {
//                if (count >= lineLimit) {
//                    trace.add("[" + (stackTrace.size - count) + "]");
//                    break;
//                }
//                boolean ignore = false;
//                if (getExcludeLowLevelStacks())
//                    ignore = ignoreTrace(element);
//                if (!ignore) {
//
//                    // line
//                    int line = element.getLineNumber();
//
//                    // method
//                    String meth = element.getMethodName();
//                    if (lastMeth.equals(meth)) meth = "*";
//                    else lastMeth = meth;
//
//                    // file name & type
//                    String[] aFile = ClassUtil.splitPath(element.getFileName());
//
//                    String fname = aFile[0];
//                    if (lastFName.equals(fname)) fname = "";
//                    else lastFName = fname;
//
//                    String ftype = aFile[1];
//                    if (ftype.equals("java")) ftype = "";
//                    else if (lastFType.equals(ftype)) ftype = "";
//                    else lastFType = ftype;
//
//                    String file;
//                    if (ftype.size() == 0)
//                        if (fname.size() == 0) file = "*";
//                        else file = fname;
//                    else file = new StringBuilder(fname).append('.').append(ftype).toString();
//
//                    // class & package
//                    String[] aPath = ClassUtil.splitPath(element.getClassName());
//
//                    String cls = aPath[1];
//                    if (fname.equals(cls)) cls = "";
//                    else if (lastCls.equals(cls)) cls = "";
//                    else lastCls = cls;
//
//                    String pckg = aPath[0];
//                    if (lastPckg.equals(pckg)) pckg = "";
//                    else lastPckg = pckg;
//
//                    String path;
//                    if (pckg.size() == 0 && cls.size() == 0) path = "*";
//                    else path = new StringBuilder(pckg).append('.').append(cls).toString();
//
//                    StringBuilder sb = new StringBuilder(path)
//                            .append(':').append(file)
//                            .append(":").append(meth)
//                            .append(":").append(line);
//                    trace.add(sb.toString());
//
//                    count++;
//                }
//            }
//            excp.add("trace", trace);
//
//        }
//        return excp;
//    }
//}