///**
// * Copyright (C) 2012 - 101loops.com <dev@101loops.com>
// *
// * Licensed under the Apache License, Version 2.0 (the "License");
// * you may not use this file except in compliance with the License.
// * You may obtain a copy of the License at
// *
// *         http://www.apache.org/licenses/LICENSE-2.0
// *
// * Unless required by applicable law or agreed to in writing, software
// * distributed under the License is distributed on an "AS IS" BASIS,
// * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// * See the License for the specific language governing permissions and
// * limitations under the License.
// */
//package com.crashnote.core.util;
//
//import java.util.Date;
//
///**
// * Simple class to force a minimum waiting time for executions.
// * <p/>
// * A wait time can be specified and a 'moment' can be captured via reset(). Then each time it
// * is asked to allow() an action, the elapsed time is compared to the wait time.
// */
//public class ThrottleUtil {
//
//    private final int scale;
//
//    private int wait = -1;
//    private boolean disabled;
//    private Long lastTry = -1L;
//
//    // INTERFACE ==================================================================================
//
//    public ThrottleUtil() {
//        this(60000);
//    }
//
//    public ThrottleUtil(final int scale) {
//        this.scale = scale;
//    }
//
//    // INTERFACE ==================================================================================
//
//    public void wait(final int t) {
//        this.wait = t * scale;
//    }
//
//    public void disable() {
//        disabled = true;
//    }
//
//    public boolean allow() {
//        return disabled || lastTry == -1L || (new Date().getTime() - lastTry) < wait;
//    }
//
//    public void reset() {
//        lastTry = new Date().getTime();
//    }
//
//    // GET ========================================================================================
//
//    public boolean isDisabled() {
//        return disabled;
//    }
//
//    public int getWait() {
//        return wait;
//    }
//}